/* PSS port addresses */

#define PSS_DATA      0x220
#define PSS_STATUS    0x222
#define PSS_CONTROL   0x222
#define PSS_ID_VERS   0x224

/* configuration addresses */

#define PSS_CONFIG    0x230
#define WSS_CONFIG    0x232
#define SB_CONFIG     0x234
#define CD_CONFIG     0x236
#define MIDI_CONFIG   0x238
#define UART_CONFIG   0x23a

/* PSS equates */

#define DMA0          0x0001
#define DMA1          0x0002
#define DMA3          0x0003
#define DMA5          0x0004
#define DMA6          0x0005
#define DMA7          0x0006

#define DMA_SPEC(num)	  (num + 1)

#define IRQ3          0x0008
#define IRQ5          0x0010
#define IRQ7          0x0018
#define IRQ9          0x0020
#define IRQ10         0x0028
#define IRQ11         0x0030
#define IRQ12         0x0038

#define IRQ_SPEC(num)	  ((num < 9) ? ((num - 1) * 0x0004) : (num - 1) * 0x0004))

#define PSS_FLAG3     0x0800
#define PSS_FLAG2     0x0400
#define PSS_FLAG1     0x1000
#define PSS_FLAG0     0x0800

#define PSS_WRITE_EMPTY  0x8000
#define PSS_READ_FULL    0x4000

#define GAME_BIT      0x0400
#define GAME_BIT_MASK 0xfbff


#define UINT    unsigned int
#define WORD    unsigned short
#define VOID    void
#define INLINE  __inline
#define DEBUG_OUTF  DebugOut
#define INT     int
#define CDECL   _cdecl
#define CHAR    char
#define PCSZ	CHAR*
#define FILE	INT
#define SHORT	short


extern SHORT nCdRomPort;
extern SHORT nCdRomIRQ;
extern SHORT nCdRomDMA;
extern SHORT nSbPort;
extern SHORT nSbIRQ;
extern SHORT nSbDMA;
extern SHORT nMpuPort;
extern SHORT nMpuIRQ;
extern SHORT nGamePort;
BOOL InitSw32 (BOOL bForceReset, PCSZ pszFile, WORD wWssBase, WORD wIrq, WORD wDma);
