#if !defined(_MYDEBUG_H)
#define _MYDEBUG_H

#if defined(__cplusplus)
extern "C" {
#endif

//    Helper macros
//
#if defined(DEBUG)
	extern char szDebugOut[256];

    #define DEBUG_OUT_HELPER(text)                              \
        {                                                       \
        OutputDebugStr(STR_PROLOGUE);                           \
        OutputDebugStr(text);                                   \
        OutputDebugStr(STR_CRLF);                               \
        OutputDebugString(text);                                \
        OutputDebugString(STR_CRLF);                            \
        }

    #define DEBUG_OUT(text)                                     \
        DEBUG_OUT_HELPER(text)

    #define DEBUG_OUT1(format, arg)                             \
        {                                                       \
        wsprintf(szDebugOut, format, arg);                 		\
        DEBUG_OUT_HELPER(szDebugOut);                      		\
        }

    #define DEBUG_OUT2(format, arg1, arg2)                      \
        {                                                       \
        wsprintf(szDebugOut, format, arg1, arg2);          		\
        DEBUG_OUT_HELPER(szDebugOut);                      		\
        }

    #define DEBUG_OUT3(format, arg1, arg2, arg3)                \
        {                                                       \
        wsprintf(szDebugOut, format, arg1, arg2, arg3);    		\
        DEBUG_OUT_HELPER(szDebugOut);                      		\
        }

    #define DEBUG_OUT4(format, arg1, arg2, arg3, arg4)          				\
        {                                                       				\
        wsprintf(szDebugOut, format, arg1, arg2, arg3, arg4);  					\
        DEBUG_OUT_HELPER(szDebugOut);                      						\
        }

    #define DEBUG_OUT5(format, arg1, arg2, arg3, arg4, arg5)        			\
        {                                                       				\
        wsprintf(szDebugOut, format, arg1, arg2, arg3, arg4, arg5); 			\
        DEBUG_OUT_HELPER(szDebugOut);                                  			\
        }

    #define DEBUG_OUT6(format, arg1, arg2, arg3, arg4, arg5, arg6)    			\
        {                                                       				\
        wsprintf(szDebugOut, format, arg1, arg2, arg3, arg4, arg5, arg6); 		\
        DEBUG_OUT_HELPER(szDebugOut);                                  			\
        }

	#define DEXEC(level, statement)												\
		if (wDebugLevel >= level) {												\
			statement;															\
			}

#else

    #define DEBUG_OUT(text)
    #define DEBUG_OUT1(format, arg)
    #define DEBUG_OUT2(format, arg1, arg2)
    #define DEBUG_OUT3(format, arg1, arg2, arg3)
    #define DEBUG_OUT4(format, arg1, arg2, arg3, arg4)
    #define DEBUG_OUT5(format, arg1, arg2, arg3, arg4, arg5)
    #define DEBUG_OUT6(format, arg1, arg2, arg3, arg4, arg5, arg6)
	#define DEXEC(level, statement)

#endif

#if !defined(ASSERT)
#define ASSERT(expr) \
        if (!(expr)) { DEBUG_OUT("***** Assertion failed: " #expr ""); }
#endif


#if defined(__cplusplus)
	}
#endif

#endif	// !defined(_MYDEBUG_H)
