#if 1
#include <vtd.h>
#endif

#if defined(MYDPF)
#undef MYDPF
#endif

#if defined(DEBUG)

	#define DWORD ULONG

	// Debugging output w/ no substitutions
	//
	//		MYDPF("Doing this and that\r\n");
	//
	#define MYDPF(text)					\
		{								\
		_asm { PUSHF }					\
		Out_Debug_String(text);			\
		Out_Debug_String("\r\n");   	\
		_asm { POPF }					\
		VTD_Delay(100000);				\
		}

	// Debugging output w/ one substitution
	//
	// 		MYDPF1("The value of x is #EAX\r\n", x);
	//
	#define MYDPF1(text, value)			\
		{								\
		DWORD dwValue = (DWORD)value; 	\
		_asm { PUSH EAX }				\
		_asm { MOV EAX, dwValue } 		\
		MYDPF(text);					\
		_asm { POP EAX }				\
		VTD_Delay(100000);				\
		}

	// Debugging output w/ two substitutions
	//
	//		MYDPF2("The value of x is #EAX; and y is #EDX\r\n", x, y);
	//
	#define MYDPF2(text, value1, value2)	\
		{								\
		DWORD dwValue2 = (DWORD)value2; \
		_asm { PUSH EDX }				\
		_asm { MOV EDX, dwValue2 }		\
		MYDPF1(text, value1);			\
		_asm { POP EAX	}				\
		VTD_Delay(100000);				\
		}

	#define ASSERT(expr) 				\
		if (!(expr))					\
			{                           \
			MYDPF("Assertion failed: " #expr); \
			_asm { int 3 }				\
			}

#else

	#define MYDPF(x)				\
		VTD_Delay(100000);

	#define MYDPF1(text, value)				\
		VTD_Delay(100000);

	#define MYDPF2(text, value1, value2)				\
		VTD_Delay(100000);

	#define ASSERT(e)

#endif
